# Notes for Windows Users

FOSS-VG is focused on development on UNIX-like systems for UNIX-like systems.
The development environment is built in a way that requires UNIX tools.

There are two options to deal with this on Windows:

1) Use Cygwin to get a UNIX-like environment on Windows.
This is the option to choose if you want to develop FOSS-VG on Windows.
Working on FOSS-VG on Cygwin is pretty much the same as on other
operating systems with the exception that special care needs to be taken
setting up the development environment.

2) Use the `windows` branch.
This is the option to use when just building on Windows.
Might need some fixing up to actually work properly.
Don't commit new code to that branch as it cannot be merged back into master.
Merging from the `windows` branch into master would break master for all other
operating systems.

# Using Cygwin

The build system has special provisions built-in to deal with the Windows-iness
of Cygwin environments. But it still needs some specific setup to work properly.

When getting the prerequisites set up, make sure to install CMake on Windows,
NOT on Cygwin. CMake is used for dependencies that aren't easy to build
on Cygwin, therefore they are built on Windows.

You will also need MinGW tools on Windows that CMake can use to build the
dependencies. In case they aren't in your PATH variable, you can use the
`.localenv.bashrc` to automatically add them when loading the development
environment like so:
```sh
PATH=$PATH:/cygdrive/c/path/to/your/mingw/bin
```
Note that the mingw tools are added to the end of the path variable so they
don't override Cygwin's programs in regular use.

# Using the `windows` Branch

Good luck.

It's currently not actively being maintained as only building FOSS-VG is not
a task that is commonly needed.
This will probably change when Windows-only builds have to be performed
regularly.
