#!/usr/bin/env bash

# Copyright 2022, FOSS-VG Developers and Contributers
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, version 3.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# version 3 along with this program.
# If not, see https://www.gnu.org/licenses/agpl-3.0.en.html

echo ">>> Cleaning build files..."

source scripts/lib.sh

remove ./bin
remove ./include
remove .endianness
remove resources/check_endianness
create_directory ./bin
create_directory ./bin/lib
create_directory ./bin/lib/net
create_directory ./include

if uname -s | tr [:upper:] [:lower:] | grep cygwin >/dev/null; then
    ln -vs ../../dependencies/sockpp-0.7.1/build/cygsockpp-0.dll bin/lib/libsockpp.so
    ln -vs ../../dependencies/sockpp-0.7.1/build/cygsockpp-0.dll bin/lib/
else
    ln -vs ../../dependencies/sockpp-0.7.1/build/libsockpp.so bin/lib/
    ln -vs ../../dependencies/sockpp-0.7.1/build/libsockpp.so.0 bin/lib/
    ln -vs ../../dependencies/sockpp-0.7.1/build/libsockpp.so.0.7.1 bin/lib/
fi

ln -vs ../dependencies/sockpp-0.7.1/include/sockpp/ ./include/
ln -vs ../dependencies/tiny-utf8-4.4.3/include/tinyutf8/ ./include/

create_file ./bin/.placeholder
create_file ./include/.placeholder
